ubuntu 는 컴 파일 된 nginx 를 service 에 추가 합 니 다.
21568 단어 nginx
#!/bin/sh
### BEGIN INIT INFO
# Provides: [email protected]
# Required-Start:
# Required-Stop:
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: nginx
# Description: nginx server
### END INIT INFO
. /lib/lsb/init-functions
PROGRAM=/usr/local/openresty//nginx/sbin/nginx
test -x $PROGRAM || exit 0
case "$1" in
start)
#detect the status of nginx pid
Statusflag=`ps -ef | grep nginx | wc -l`
#the min number is 3,even if the nginx is not running
if [ $Statusflag -gt 3 ]; then
log_begin_msg "Nginx is already running"
log_end_msg 0
else
log_begin_msg "Starting Nginx server"
/usr/local/openresty/nginx/sbin/nginx
log_end_msg 0
fi
;;
stop)
#detect the status of nginx pid
Statusflag=`ps -ef | grep nginx | wc -l`
#the min number is 3,even if the nginx is not running
if [ $Statusflag -gt 3 ]; then
PID=`ps -ef | grep nginx | head -1 | awk '{print $2}'`
log_begin_msg "Stopping Nginx server"
if [ ! -z "$PID" ]; then
kill -15 $PID
fi
log_end_msg 0
else
log_begin_msg "Nginx is not running"
log_end_msg 0
fi
;;
status)
Statusflag=`ps -ef | grep nginx | wc -l`
#the min number is 3,even if the nginx is not running
if [ $Statusflag -gt 3 ]; then
log_begin_msg "Nginx is running"
else
log_begin_msg "Nginx is not running"
fi
log_end_msg 0
;;
restart)
#$0 stop ##It would be wrong to call this function directly.
#detect the status of nginx pid
Statusflag=`ps -ef | grep nginx | wc -l`
#the min number is 3,even if the nginx is not running
if [ $Statusflag -gt 3 ]; then
PID=`ps -ef | grep nginx | head -1 | awk '{print $2}'`
log_begin_msg "Stopping Nginx server"
if [ ! -z "$PID" ]; then
kill -15 $PID
fi
log_end_msg 0
else
log_begin_msg "Nginx is not running"
log_end_msg 0
fi
#$0 start it would be wrong to call this function directly.
log_begin_msg "Starting Nginx server"
/usr/local/openresty/nginx/sbin/nginx
log_end_msg 0
;;
*)
log_success_msg "Usage: service nginx {start|stop|restart|status}"
exit 1
esac
exit 0
이 내용 을 nginx 로 저장 하여 / etc / init. d / 디 렉 터 리 에 두 고 실행
sudo chmod +x ./nginx
sudo update-rc.d nginx defaults
하면 service nginx {start | stop | restart | status} 을 사용 할 수 있 습 니 다. status 를 지원 하 는 것 이 장점 입 니 다. 인터넷 스 크 립 트 는 대부분 status 를 보지 않 았 습 니 다.단점 은 nginx. pid 에서 프로 세 스 실행 상황 을 찾 지 않 고 ps 명령 으로 nginx 프로 세 스 정 보 를 직접 검색 하면 kill - 15 가 막 혀 서 프로 세 스 를 죽 일 수 없습니다.마지막 으로 공식 적 으로 쓰 는 것 이 가장 좋 지만 자신 이 컴 파일 한 바 이 너 리 프로그램 은 upgrade 옵션 을 취소 하 는 것 을 권장 합 니 다. 바 이 너 리 프로그램 이 바 뀌 기 때문에 공식 적 인 것 을 붙 입 니 다.
#!/bin/sh
### BEGIN INIT INFO
# Provides: nginx
# Required-Start: $local_fs $remote_fs $network $syslog $named
# Required-Stop: $local_fs $remote_fs $network $syslog $named
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: starts the nginx web server
# Description: starts nginx using start-stop-daemon
### END INIT INFO
PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DAEMON=/usr/sbin/nginx
NAME=nginx
DESC=nginx
# Include nginx defaults if available
if [ -r /etc/default/nginx ]; then
. /etc/default/nginx
fi
test -x $DAEMON || exit 0
. /lib/init/vars.sh
. /lib/lsb/init-functions
# Try to extract nginx pidfile
PID=$(cat /etc/nginx/nginx.conf | grep -Ev '^\s*#' | awk 'BEGIN { RS="[;{}]" } { if ($1 == "pid") print $2 }' | head -n1)
if [ -z "$PID" ]
then
PID=/run/nginx.pid
fi
# Check if the ULIMIT is set in /etc/default/nginx
if [ -n "$ULIMIT" ]; then
# Set the ulimits
ulimit $ULIMIT
fi
#
# Function that starts the daemon/service
#
do_start()
{
# Return
# 0 if daemon has been started
# 1 if daemon was already running
# 2 if daemon could not be started
start-stop-daemon --start --quiet --pidfile $PID --exec $DAEMON --test > /dev/null \
|| return 1
start-stop-daemon --start --quiet --pidfile $PID --exec $DAEMON -- \
$DAEMON_OPTS 2>/dev/null \
|| return 2
}
test_nginx_config() {
$DAEMON -t $DAEMON_OPTS >/dev/null 2>&1
}
#
# Function that stops the daemon/service
#
do_stop()
{
# Return
# 0 if daemon has been stopped
# 1 if daemon was already stopped
# 2 if daemon could not be stopped
# other if a failure occurred
start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PID --name $NAME
RETVAL="$?"
sleep 1
return "$RETVAL"
}
#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
start-stop-daemon --stop --signal HUP --quiet --pidfile $PID --name $NAME
return 0
}
#
# Rotate log files
#
do_rotate() {
start-stop-daemon --stop --signal USR1 --quiet --pidfile $PID --name $NAME
return 0
}
#
# Online upgrade nginx executable
#
# "Upgrading Executable on the Fly"
# http://nginx.org/en/docs/control.html
#
do_upgrade() {
# Return
# 0 if nginx has been successfully upgraded
# 1 if nginx is not running
# 2 if the pid files were not created on time
# 3 if the old master could not be killed
if start-stop-daemon --stop --signal USR2 --quiet --pidfile $PID --name $NAME; then
# Wait for both old and new master to write their pid file
while [ ! -s "${PID}.oldbin" ] || [ ! -s "${PID}" ]; do
cnt=`expr $cnt + 1`
if [ $cnt -gt 10 ]; then
return 2
fi
sleep 1
done
# Everything is ready, gracefully stop the old master
if start-stop-daemon --stop --signal QUIT --quiet --pidfile "${PID}.oldbin" --name $NAME; then
return 0
else
return 3
fi
else
return 1
fi
}
case "$1" in
start)
[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
do_start
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
;;
stop)
[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
do_stop
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
;;
restart)
log_daemon_msg "Restarting $DESC" "$NAME"
# Check configuration before stopping nginx
if ! test_nginx_config; then
log_end_msg 1 # Configuration error
exit 0
fi
do_stop
case "$?" in
0|1)
do_start
case "$?" in
0) log_end_msg 0 ;;
1) log_end_msg 1 ;; # Old process is still running
*) log_end_msg 1 ;; # Failed to start
esac
;;
*)
# Failed to stop
log_end_msg 1
;;
esac
;;
reload|force-reload)
log_daemon_msg "Reloading $DESC configuration" "$NAME"
# Check configuration before reload nginx
#
# This is not entirely correct since the on-disk nginx binary
# may differ from the in-memory one, but that's not common.
# We prefer to check the configuration and return an error
# to the administrator.
if ! test_nginx_config; then
log_end_msg 1 # Configuration error
exit 0
fi
do_reload
log_end_msg $?
;;
configtest|testconfig)
log_daemon_msg "Testing $DESC configuration"
test_nginx_config
log_end_msg $?
;;
status)
status_of_proc -p $PID "$DAEMON" "$NAME" && exit 0 || exit $?
;;
upgrade)
log_daemon_msg "Upgrading binary" "$NAME"
do_upgrade
log_end_msg 0
;;
rotate)
log_daemon_msg "Re-opening $DESC log files" "$NAME"
do_rotate
log_end_msg $?
;;
*)
echo "Usage: $NAME {start|stop|restart|reload|force-reload|status|configtest|rotate|upgrade}" >&2
exit 3
;;
esac
:
이 내용에 흥미가 있습니까?
현재 기사가 여러분의 문제를 해결하지 못하는 경우 AI 엔진은 머신러닝 분석(스마트 모델이 방금 만들어져 부정확한 경우가 있을 수 있음)을 통해 가장 유사한 기사를 추천합니다:
간단! Certbot을 사용하여 웹 사이트를 SSL(HTTPS)화하는 방법초보자가 인프라 주위를 정돈하는 것은 매우 어렵습니다. 이번은 사이트를 간단하게 SSL화(HTTP에서 HTTPS통신)로 변경하는 방법을 소개합니다! 이번에는 소프트웨어 시스템 Nginx CentOS7 의 환경에서 S...
텍스트를 자유롭게 공유하거나 복사할 수 있습니다.하지만 이 문서의 URL은 참조 URL로 남겨 두십시오.
CC BY-SA 2.5, CC BY-SA 3.0 및 CC BY-SA 4.0에 따라 라이센스가 부여됩니다.